{%- import "src/_interop_utils.j2" as interop_utils with context -%}


{% set local_ns = namespace() %}
{%- set local_ns.var_stack = [] -%}

{% set extended_rda_map = [] %}
{% set map_elt = {
"rda_anchor" : none,
"rda_github_link" : none,
"rda_object_cardinality" : none
}
%}
{% set rda_github_link = "https://github.com/RDA-DMP-Common/RDA-DMP-Common-Standard?tab=readme-ov-file" %}


{% macro displayRDATreeHref(href, text, with_colour) %}
  {% if with_colour %}
    {{ "<b><a href=" ~  rda_github_link ~ href ~ " target=\"_blank\"><font color=\"Lime\">" ~ text ~ "</font></a></b>" }}
  {% else %}
    {{ "<a href=" ~  rda_github_link ~ href ~ " target=\"_blank\"><font color=\"LightSeaGreen\">" ~ text ~ "</font></a>" }}
  {% endif %}
{% endmacro %}

{% macro displayQuestionnaireHrefs(globals, tree_item_id) %}
  {% set local_ns.number = 0 %}
  {% for anchor in globals.rda_tree_item_2_anchors_map[tree_item_id] %}
    {% set local_ns.number = local_ns.number + 1 %}
    {% set href = "#" ~ anchor %} 
     {{ "<a href=" ~  href ~ " target=\"_blank\">" ~ "&rarr; DMP item " ~ local_ns.number ~ "</a>" }}
  {% endfor %}
{% endmacro %}

{% macro displayCardinality(cardinality) %}
  {{ "<span style=\"color:Red\"><b>" ~  cardinality ~ "</b></span>" }}
{% endmacro %}




{%- macro write_line(globals, line) -%}
  {# I want a different color if the rda tree item is referred to by a questionnaire annotation #}
  {% if globals.rda_tree_item_2_anchors_map[line['item_id']]|length == 0 %}
    {{ "<a id=" ~ line['item_id'] ~ "></a>" ~ displayRDATreeHref(line['item_href'], line['item_text'], false) ~ displayCardinality(line['item_card']) ~ displayQuestionnaireHrefs(globals, line['item_id']) }}
  {% else %}
    {{ "<a id=" ~ line['item_id'] ~ "></a>" ~ displayRDATreeHref(line['item_href'], line['item_text'], true) ~ displayCardinality(line['item_card']) ~ displayQuestionnaireHrefs(globals, line['item_id']) }}
  {% endif %}
{%- endmacro -%}



{%- macro rewrite_rda_recursive(globals, dmp_list) -%}
  {#- assumption: dmp_list is always a list -#}
  {#- and the list can only contain other lists or mappings -#}

  {%- for i in range(dmp_list|length) -%}
    {%- if dmp_list[i] is mapping -%}
      {%- if i < (dmp_list|length) - 1 and dmp_list[i + 1] is sequence   
        and dmp_list[i + 1] is not mapping -%}
        {{ "\n<details open>" }}
        {{ "\n<summary>" }}
        {{ write_line(globals, dmp_list[i]) }} 
        {{ "\n</summary>" }}
        {{ "\n<p>" }}
      {%- else -%}
        {{ "<br>" ~ write_line(globals, dmp_list[i]) }}
      {%- endif -%}
    {%- elif dmp_list[i] is sequence   
      and dmp_list[i] is not mapping -%}
      {#- a mapping is also... a sequence... -#}
      {{ rewrite_rda_recursive(globals, dmp_list[i]) }}
    {%- endif -%}
    {%- if i == (dmp_list|length) - 1 -%}
      {{ "\n</p>" }}
      {{ "\n</details>" }}
    {%- endif -%}
  {%- endfor -%}

{%- endmacro -%}

{% macro rewrite_rda_tree(globals, rda_tree) %}

  {%- set local_ns.list_of_lists = [] -%}
  {%- set local_ns.dmp_list = null -%}

  {#- no time to comment sorry -#}
  {% for key, line in rda_tree.items() %}
    {% if 'section' in line %}
      {%- set line_section = line['section']|trim -%}
      {%- if line_section == "<ul>" -%}
        {%- set new_list = [] -%}
        {%- if local_ns.dmp_list -%}
          {%- set concerned_list = local_ns.list_of_lists|last -%}
          {%- do concerned_list.append(new_list) -%}
        {%- else -%}
          {%- set local_ns.dmp_list = new_list -%}
        {%- endif -%}
        {%- do local_ns.list_of_lists.append(new_list) -%}
      {%- elif line_section == "</ul>" -%}
        {%- do local_ns.list_of_lists.pop() -%}
      {%- endif -%}
    {%- else -%}
      {%- set concerned_list = local_ns.list_of_lists|last -%}
      {%- do concerned_list.append(line) -%}
    {%- endif -%}
  {% endfor %}
{#-  {{ local_ns.dmp_list }} -#}

  {{ rewrite_rda_recursive(globals, local_ns.dmp_list) }}
{% endmacro %}


{% macro rewrite_map(globals, annotation) %}

  {# first, construct the anchor #}
  {% set value = globals.rda_annotation_map[annotation] %}
  {#  {{ annotation ~ " " ~ value }} <br> #}
  {% set local_ns.anchor = none %}
  {% set local_ns.append = false %}
  {% for i in range(value|length) %}
    {% if value[i] == "#" %}
      {% set local_ns.append = true %}
    {% elif local_ns.append and (value[i] == "\"" or value[i] == "'") %}
      {% set local_ns.append = false %}
    {% endif %}
    {% if local_ns.append %}
      {% if not local_ns.anchor %}
        {% set local_ns.anchor = value[i] %}
      {% else %}
        {% set local_ns.anchor = local_ns.anchor ~ value[i] %}
      {% endif %}
    {% endif %}
  {% endfor %}
  {% set original_target_in_rda_tree = local_ns.anchor %}

  {# remove the first character \# #} 
  {% if local_ns.anchor %}
    {% set local_ns.copy = "" %}
    {% for i in range(local_ns.anchor|length) %}
      {% if i > 0 %}
         {% set local_ns.copy = local_ns.copy ~ local_ns.anchor[i] %}
       {% endif %}
    {% endfor %}
    {% set local_ns.anchor = local_ns.copy %}
  {% endif %}
  {% set original_target_in_rda_tree_stripped = local_ns.anchor %}
  {# original_target_in_rda_tree_stripped is #}
  {# i) the href link for the DSW entity's annotation, link to an rda_tree element on the same page #}
  {# ii) it will also serve as a key in the third map created here, see below #}

  {# create the anchors of the questionnaires entities, one anchor per entity #}
  {# these anchors will be the href links inserted with the on page rda_tree elements #}
  {# make sure that all anchors are numbered #}
  {% if local_ns.anchor %}
    {% set nVar = globals.anchors|select("equalto", local_ns.anchor)|list|count %}
    {% if nVar == 0 %}
      {% do globals.anchors.append(local_ns.anchor) %}
      {% set local_ns.anchor = local_ns.anchor ~ "_1" %}
    {% else %}
      {% do globals.anchors.append(local_ns.anchor) %}
      {% set nVar = nVar + 1 %}
      {% set local_ns.anchor = local_ns.anchor ~ "_" ~ nVar %}
      {% do globals.anchors.append(local_ns.anchor) %}
    {% endif %}
    {#     {{ local_ns.anchor }} <br> #}
  {% endif %}

  {# create map annotation -> link to rda_tree on page #}
  {%- set local_ns.annotation_found = false -%}
  {%- if annotation in globals.annotation_2_rda_tree_target_map -%}
    {%- set local_ns.annotation_found = true -%}
  {%- endif -%}
  {% if not local_ns.annotation_found %}
    {% do globals.annotation_2_rda_tree_target_map.update({ annotation : original_target_in_rda_tree }) %}
  {% endif %}

  {# create map annotation -> to all the anchors, hrefs in rda_tree that will be referring back to #}
  {# the annotation #}
  {% if local_ns.anchor %}
    {%- set local_ns.annotation_found = false -%}
    {%- if annotation in globals.annotation_2_anchors_map -%}
      {%- set local_ns.annotation_found = true -%}
      {%- set value = globals.annotation_2_anchors_map[annotation] -%}
      {%- do value.append(local_ns.anchor) -%} 
    {%- endif -%}
    {% if not local_ns.annotation_found %}
      {%- set value = [] -%}
      {%- do value.append(local_ns.anchor) -%}
      {% do globals.annotation_2_anchors_map.update( { annotation : value }) %} 
    {% endif %}
  {% endif %}

  {# create map original_target_in_rda_tree_stripped -> hrefs pointing to questionnaire entities #}
  {# questionnaire which is displayed above the rda_tree #}
  {% if original_target_in_rda_tree_stripped %}
    {%- set local_ns.target_found = false -%}
    {%- if original_target_in_rda_tree_stripped in globals.rda_tree_item_2_anchors_map -%}
      {%- set local_ns.target_found = true -%}
      {%- set value = globals.rda_tree_item_2_anchors_map[original_target_in_rda_tree_stripped] -%}
      {%- do value.append(local_ns.anchor) -%} 
    {%- endif -%}
    {% if not local_ns.target_found %}
      {%- set value = [] -%}
      {%- do value.append(local_ns.anchor) -%}
      {% do globals.rda_tree_item_2_anchors_map.update( { original_target_in_rda_tree_stripped : value }) %} 
    {% endif %}
  {% endif %}

 {# {{ globals.anchors }} <br> #}
 {#  {{ globals.question_annotation_2_anchors_map }}  #}
{% endmacro %}
 





{% macro displayAnnotationMapping(global_maps, annotations) %}
  {% for key, annotation in annotations.items() %}
    {% if key == "interop" %}
      {{ "<span style=\"color:SlateBlue\"><b> &rarr; " ~ global_maps.rda_annotation_map[annotation]  ~ displayAnchors(global_maps, annotation) ~ "</b></span>"}}
      {% endif %}
  {% endfor %}
{% endmacro %}


{% macro displayAnchors(global_maps, annotation) %}
  {% for anchor in global_maps.annotation_2_anchors_map[annotation] %}
    {{ "<a name=\"" ~ anchor ~ "\" ></a>" }}
  {% endfor %}
{% endmacro %}

{% macro displayAnnotation(annotations) %}
  {% for key, annotation in annotations.items() %}
    {% if key == "interop" %}
      {{ "<span style=\"color:green\"><b> " ~ annotation ~ "</b></span>,"}}
    {% endif %}
  {% endfor %}
{% endmacro %}

{% macro displayReply(reply) %}
  {{ "<span style=\"color:blue\"><b>" ~  reply ~ "</b></span>"}}
{% endmacro %}

{% macro displayIndent(indent) %}
  {% set local_ns.indent = "" %}
  {% for i in range(indent) %}
    {% set local_ns.indent = local_ns.indent  ~ "&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;" %}
  {% endfor %}
  {{ local_ns.indent }}
{% endmacro %}

{# below not used ... yet #}
{% macro displayEntityAnnotation(str, entityType, uuid, parent, indent, annotations, reply)  %}
    {{ displayDicVar(str, entityType, uuid, parent, indent, annotations, reply) }}
{% endmacro %}


{% macro displayDicVarWithMapping(global_maps, global_vars, str, entityType, uuid, parent, indent, annotations, reply) %}
  {% if global_vars.list_of_annotations_only %}
    {{ displayAnnotation(annotations) }}
    </br>
  {% else %}
    {% if reply %}
      {{ displayIndent(indent) ~ str ~ ", " ~ entityType ~ ", " ~  displayAnnotation(annotations) ~ displayAnnotationMapping(global_maps, annotations) ~ displayReply(reply) }}
    {% else %}
      {{ displayIndent(indent) ~ str ~ ", " ~ entityType ~ ", " ~  displayAnnotation(annotations) ~ displayAnnotationMapping(global_maps, annotations) }}
    {% endif %}
    </br>
  {% endif %}
{% endmacro %}


{% macro displayEntityAnnotationWithMapping(global_maps, global_vars, str, entityType, uuid, parent, indent, annotations, reply)  %}
  {% for key, annotation in annotations.items() %}
    {% if key == "interop" %}
      {# this is very dirty, but... being in a hurry... #}
      {# choice of annotations should be done at a much higher level etc... #}
      
      {{ rewrite_map(global_maps, annotation) }}
    {% endif %}
  {% endfor %}
  {{ displayDicVarWithMapping(global_maps, global_vars, str, entityType, uuid, parent, indent, annotations, reply) }}
{% endmacro %}
  
{% macro displayDicVar(str, entityType, uuid, parent, indent, annotations, reply) %}
  {% if reply %}
    {{ displayIndent(indent) ~ str ~ ", " ~ entityType ~ ", " ~  displayAnnotation(annotations) ~ displayReply(reply) }}
  {% else %}
    {{ displayIndent(indent) ~ str ~ ", " ~ entityType ~ ", " ~  displayAnnotation(annotations) }}
  {% endif %}
    </br>
{% endmacro %}



{# ------------------------------------------------------------------------------------------------------ #}
{# below: obsolete? maybe not yet #}
{# ------------------------------------------------------------------------------------------------------ #}

{% set alphaNum = [ "a", "b", "c", "d", "e", "f", "g", "h", "i", "j",
"k", "l", "m", "n", "o", "p", "q", "r", "s", "t", "u", "v", "w", "x",
"y", "z", "0", "1", "2", "3", "4", "5", "6", "7", "8", "9", "A", "B",
"C", "D", "E", "F", "G", "H", "I", "J", "K", "L", "M", "N", "O", "P",
"Q", "R", "S", "T", "U", "V", "W", "X", "Y", "Z", "_" ] %}
{% set num = [ "0", "1", "2", "3", "4", "5", "6", "7", "8", "9"] %}

{% set listOfVarNames = [] %}
{% set dicOfVarNames = [] %}

{# this macro is not called currently, but I'll keep it, could become useful? #}
{% macro processVarName(str, entityType, uuid, parent, indent, annotations, reply) %} 
  
  {% set local_ns.varName = str|string|trim|replace(" ","_") %}

  {% set local_ns.varName = local_ns.varName|replace("é","e") %}
  {% set local_ns.varName = local_ns.varName|replace("è","e") %}
  {% set local_ns.varName = local_ns.varName|replace("ê","e") %}

  {% set local_ns.varName = local_ns.varName|replace("á","a") %}
  {% set local_ns.varName = local_ns.varName|replace("à","a") %}
  {% set local_ns.varName = local_ns.varName|replace("â","a") %}

  {% set local_ns.varName = local_ns.varName|replace("í","i") %}
  {% set local_ns.varName = local_ns.varName|replace("ì","i") %}
  {% set local_ns.varName = local_ns.varName|replace("î","i") %}

  {% set local_ns.varName = local_ns.varName|replace("ó","o") %}
  {% set local_ns.varName = local_ns.varName|replace("ô","o") %}
  {% set local_ns.varName = local_ns.varName|replace("ò","o") %}
  
  {% set local_ns.varName = local_ns.varName|replace("ú","u") %}
  {% set local_ns.varName = local_ns.varName|replace("ù","u") %}
  {% set local_ns.varName = local_ns.varName|replace("û","u") %}

  {% set local_ns.varName = local_ns.varName|replace("È","E") %}
  {% set local_ns.varName = local_ns.varName|replace("É","E") %}
  {% set local_ns.varName = local_ns.varName|replace("Ê","E") %}

  {% set local_ns.varName = local_ns.varName|replace("À","A") %}
  {% set local_ns.varName = local_ns.varName|replace("Á","A") %}
  {% set local_ns.varName = local_ns.varName|replace("Â","A") %}

  {% set local_ns.varName = local_ns.varName|replace("Í","I") %}
  {% set local_ns.varName = local_ns.varName|replace("Ì","I") %}
  {% set local_ns.varName = local_ns.varName|replace("Î","I") %}

  {% set local_ns.varName = local_ns.varName|replace("Ó","O") %}
  {% set local_ns.varName = local_ns.varName|replace("Ô","O") %}
  {% set local_ns.varName = local_ns.varName|replace("Ò","O") %}
  
  {% set local_ns.varName = local_ns.varName|replace("Ú","U") %}
  {% set local_ns.varName = local_ns.varName|replace("Ù","U") %}
  {% set local_ns.varName = local_ns.varName|replace("Û","U") %}

  {% set local_ns.varName = local_ns.varName|replace("ç","c") %}

  {% for i in range(local_ns.varName|length) %}
    {% set c = local_ns.varName[i] %} 
    {% if c in alphaNum %}
    {% else %}
        {% set local_ns.varName = local_ns.varName|replace(c, "_") %}
    {% endif %}
  {% endfor %}

  {% if local_ns.varName[0] in num %}
    {% set varName = "n_" ~ local_ns.varName %}
    {% set local_ns.varName = varName %}
  {% endif %}

  {% set local_ns.varName = local_ns.varName ~ "_" ~ entityType ~ "_uuid" %}
  
  {% set nVar = listOfVarNames|select("equalto", local_ns.varName)|list|count %}
  {% if nVar == 0 %}
    {% set local_ns.varName = local_ns.varName %}
    {% do listOfVarNames.append(local_ns.varName) %}
  {% else %}
    {% do listOfVarNames.append(local_ns.varName) %}
    {% set nVar = nVar + 1 %}
    {% set local_ns.varName = local_ns.varName ~ "_" ~ nVar %}
     {% do listOfVarNames.append(local_ns.varName) %}
  {% endif %}

  {{ updateDicVars(str, local_ns.varName, entityType, uuid, str, parent, indent, annotations, reply) }}

{% endmacro %} 


{% macro updateDicVars(title, varName, entityType, uuid, label, parent, indent, annotations, reply) %}
  
  {% set varEntry = {} %}
  {% do varEntry.update({ "title" : title })  %}
  {% do varEntry.update({ "name" : varName })  %}
  {% do varEntry.update({ "uuid" : uuid })  %}
  {% do varEntry.update({ "type" : entityType })  %}
  {% do varEntry.update({ "label" : label }) %}
  {% do varEntry.update({ "parent" : parent }) %}
  {% do varEntry.update({ "indent" : indent }) %}
  {% do varEntry.update({ "annotations" : annotations }) %}
  {% do varEntry.update({ "reply" : reply }) %}
 
  {% do dicOfVarNames.append(varEntry) %}

{% endmacro %}

{# this macro I believe is useless now #}
{% macro listDicOfVarNames() %}
  
  {% for elt in dicOfVarNames %}
    {{ displayIndent(elt.indent) ~ elt.title ~ ", " ~ elt.type ~ ", " ~  elt.annotations ~ ", " ~  elt.reply }}
 {#   uuid: {{ elt.uuid }} #}
 {#   label: {{ elt.label }} #}
 {#   parent: {{ elt.parent }} #}
    </br>
  {% endfor %}

{% endmacro %}

